/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_DRIVERHEADER_H
#define IMPL_TYPE_DRIVERHEADER_H

#include "impl_type_int32.h"
#include "impl_type_string.h"

struct DriverHeader {
    ::Int32 stampHigh{ 0 };
    ::Int32 stampLow{ 0 };
    ::String frameId;

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(stampHigh);
        fun(stampLow);
        fun(frameId);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(stampHigh);
        fun(stampLow);
        fun(frameId);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("stampHigh", stampHigh);
        fun("stampLow", stampLow);
        fun("frameId", frameId);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("stampHigh", stampHigh);
        fun("stampLow", stampLow);
        fun("frameId", frameId);
    }

    friend bool operator==(const ::DriverHeader& lhs, const ::DriverHeader& rhs) noexcept
    {
        return (lhs.stampHigh == rhs.stampHigh) && (lhs.stampLow == rhs.stampLow) && (lhs.frameId == rhs.frameId);
    }
};


#endif // IMPL_TYPE_DRIVERHEADER_H
